#!/usr/bin/env bash
workdir=$1
source $workdir/../multi-host.conf
testLog=$workdir/logs/hub_discovery.log

clean_up_nodeB() {
  r=$(sudo killall nfd 2>&1)
  sudo mv resolv.conf.bak /etc/resolv.conf
  sleep 2
}

mkdir -p $workdir/logs;
sudo nfd &> $workdir/logs/nfd.log &
sleep 2

ndnsec-keygen /tmp/autoconfig-test | ndnsec-install-cert -
sudo cp /etc/resolv.conf resolv.conf.bak
echo "nameserver $IP4_A1" > resolv.conf
echo "search autoconfig-test.named-data.net" >> resolv.conf
sudo mv resolv.conf /etc/resolv.conf

sudo cat /etc/resolv.conf >> $testLog

ndn-autoconfig
sleep 2

# search output for 10.63.18.1, fail if not found
face=$(nfd-status -f | grep -F remote=udp4://10.63.18.1)
if [[ -z "$face" ]]; then
  clean_up_nodeB
  exit 1
fi

# search output for 10.63.18.2, fail if found.
face=$(nfd-status -f | grep -F remote=udp4://10.63.18.2)
if [[ -n "$face" ]]; then
  clean_up_nodeB
  exit 1
fi

#search output for 10.63.18.3, fail if found.
face=$(nfd-status -f | grep -F remote=udp4://10.63.18.3)
if [[ -n "$face" ]]; then
  clean_up_nodeB
  exit 1
fi

clean_up_nodeB
exit 0
